--CONFIG--
local SLRT__version = 1
local SLRT__newRose = "Interface\\AddOns\\StarlightRoseTracker\\ding.ogg"
local SLRT__color = "FFA500"
local SLRT__counter_button_image = "Interface\\Addons\\StarlightRoseTracker\\rose.tga"
--END CONFIG--

if not SLRT__isAll then
  SLRT__isAll = false
end

local SLRT__string = "|cff" .. SLRT__color:lower() .. "[SLRT] "
local SLRT__frame
local text
local background



local SLRT__oldCount = GetItemCount(124105)
local SLRT__oldCountDust = GetItemCount(129158) 
local SLRT__count = 0
local SLRT__countDust = 0

if not SLRT__roseCount then
  SLRT__roseCount = 0
end

local function explode(div,str) -- credit: http://richard.warburton.it
  if (div=='') then return false end
  local pos,arr = 0,{}
  -- for each divider found
  for st,sp in function() return string.find(str,div,pos,true) end do
    table.insert(arr,string.sub(str,pos,st-1)) -- Attach chars left of current divider
    pos = sp + 1 -- Jump past current divider
  end
  table.insert(arr,string.sub(str,pos)) -- Attach chars right of last divider
  return arr
end

if not SLRT__isHerbalist then
  SLRT__isHerbalist = true
end

SLRT__frame = CreateFrame("Frame", "DragFrame2", UIParent)
function SLRT__setupFrame()
  SLRT__frame:SetMovable(true)
  SLRT__frame:EnableMouse(true)
  SLRT__frame:RegisterForDrag("LeftButton")
  SLRT__frame:SetScript("OnDragStart", SLRT__frame.StartMoving)
  SLRT__frame:SetScript("OnDragStop", SLRT__frame.StopMovingOrSizing)
  SLRT__frame:SetPoint("CENTER")
  SLRT__frame:SetWidth(32)
  SLRT__frame:SetHeight(32)
  SLRT__frame:SetScript("OnUpdate", function(self, sinceLastUpdate) SLRT__frame:onUpdate(sinceLastUpdate); end);

  SLRT__background = SLRT__frame:CreateTexture(nil, "BACKGROUND")
  SLRT__background:SetTexture(SLRT__counter_button_image)
  SLRT__background:SetPoint("CENTER",0,0)

  if not SLRT__text then
    SLRT__text = SLRT__frame:CreateFontString(nil, "OVERLAY", "GameFontNormalLarge")
    SLRT__text:SetPoint("CENTER")
  end
  
  if SLRT__roseCount then
    SLRT__text:SetText("")
    SLRT__text:SetText("|cff" .. SLRT__color:lower() .. SLRT__roseCount)
  end
end

SLRT__setupFrame()

SLASH_SLRT1 = '/slrt'
function SlashCmdList.SLRT(msg, editbox)
  msg = msg or ""
  local args = explode(" ", msg)
  if args[1] == "help" or args[1] == "" then
    print(SLRT__string .. "Commands:")
    print(SLRT__string .. "/slrt help: See all the commands added by Starlight Rose Tracker.")
    print(SLRT__string .. "/slrt rl: Reset the counter location.")
    print(SLRT__string .. "/slrt reset: Reset the rose counter's number.")
    print(SLRT__string .. "/slrt toggledust: Toggles if it plays the sound on getting dust.")
    print(SLRT__string .. "/slrt herbalist: Toggles if the counter displays on this character.")
    print(SLRT__string .. "/slrt reload: Reloads the counter, if it's out of sync or it breaks.")
    print(SLRT__string .. "/slrt sound: Plays the \"ding\" sound.")
  elseif args[1] == "rl" then
   SLRT__frame:ClearAllPoints();
   SLRT__frame:SetPoint("CENTER");
   print(SLRT__string .. "Reset counter location.")
  elseif args[1] == "reset" then
   SLRT__roseCount = 0
   SLRT__text:SetText("|cff" .. SLRT__color:lower() .. SLRT__roseCount)
   print(SLRT__string .. "Reset rose counter.")
  elseif args[1] == "toggledust" then
   SLRT__isAll = not SLRT__isAll
   if SLRT__isAll then
     print(SLRT__string .. "Picking up dust now plays the sound.")
   else
     print(SLRT__string .. "Picking up dust no longer plays the sound.")
   end
  elseif args[1] == "herbalist" then
   SLRT__isHerbalist = not SLRT__isHerbalist
   if SLRT__isHerbalist then
     print(SLRT__string .. "You are now considered an herbalist.")
   else
     print(SLRT__string .. "You are no longer considered an herbalist.")
   end
  elseif args[1] == "reload" then
    SLRT__setupFrame()
  elseif args[1] == "sound" then
    PlaySoundFile(SLRT__newRose)
  end
end
  

local hasInit = false
local hasDe = false
function SLRT__frame:onUpdate(sinceLastUpdate) --Thanks Woogs! http://www.mmo-champion.com/threads/1215472-Suppose-I-want-to-call-a-function-on-a-timer-rather-than-as-a-response-to-an-event
  self.sinceLastUpdate = (self.sinceLastUpdate or 0) + sinceLastUpdate;
  if (self.sinceLastUpdate >= 0.2) and SLRT__isHerbalist then
    if hasDe then --this means that you've enabled it after disabling
      SLRT__setupFrame()
      hasDe = false
      hasInit = true
    end
    if not hasInit then
      SLRT__text:SetText("|cff" .. SLRT__color:lower() .. SLRT__roseCount)
      print(SLRT__string .. "Starlight Rose Tracker v" .. SLRT__version .. " initalized.")
      print(SLRT__string .. "Type \"/slrt help\" to view available commands.")
      hasInit = true
    end
    --124105 = starlight rose
    --129158 = starlight rosedust
    SLRT__count = GetItemCount(124105, true)
    SLRT__countDust = GetItemCount(129158, true)
    if (SLRT__count > SLRT__oldCount) or (SLRT__countDust > SLRT__oldCountDust) then
      local SLRT__minus
      if SLRT__count > SLRT__oldCount then
        SLRT__minus = SLRT__count-SLRT__oldCount
      else
        SLRT__minus = SLRT__countDust-SLRT__oldCountDust
      end
      if SLRT__minus <= 1 then
        SLRT__roseCount = SLRT__roseCount + 1
        SLRT__text:SetText("|cff" .. SLRT__color:lower() .. SLRT__roseCount)
        if not SLRT__isAll then
         if not (SLRT__countDust > SLRT__oldCountDust) then
          PlaySoundFile(SLRT__newRose)
         end
        else
          PlaySoundFile(SLRT__newRose)
        end
      end
    end
    SLRT__oldCount = GetItemCount(124105, true)
    SLRT__oldCountDust = GetItemCount(129158, true)
    self.sinceLastUpdate = 0;
  elseif SLRT__isHerbalist == false and not hasDe then
    SLRT__background:SetTexture("")
    SLRT__text:SetText("")
    hasDe = true
  end
end
